/* CS-PSeq-Gen specific part               
 * Management of clusters of co-subtituting sites
 * 
 * by P. Tuffery (1997-2000) 
 * INSERM U436, Universite Paris 7, France
 *
 * The external data entry point is pCS
 * Require rates to be setup for some functions.
 * Require nodeNames for some functions.
 */

#ifndef __CSFuncs_h__
#define __CSFuncs_h__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <math.h>

#include "CSTypes.h"

extern int gEvolveMode;
extern int gBranchMutMode;

extern char iCSCfgFileName[256];
extern char oCSCfgFileName[256];
extern int gCSUse;

extern DtCSRec        *pCS;     /* Default entry point to CS data */
extern DtCSClsDef CSClsParms;

extern void argstrCSPrmtrsUsage();
extern void parseArgstrCSPrmtrs(int argc,char *argv[]);
extern void CS_Usage(DtCSRec *CS);
extern void CS_Infos(FILE *fd, DtCSRec *CS);
extern void CS_CfgWrite(char *fname, DtCSRec *CS);

/* This is the default function to call */
extern DtCSRec *CS_Setup(TTree *tree, char *fname, DtCSRec *CS, int aSze, FILE *flis);
extern DtCSRec *CS_Setup2(TTree *tree, char *fname, DtCSRec *CS, int aSze, FILE *flis);

/* These functions for detection  */
extern void CS_detectInit(DtCSRec *pCs);
extern void CS_CSTreeCount(TTree *tree, int which, int **where, int aSze, DtSiteCSRec *CM, int *nCS);
extern void CS_SSTreeCount(TTree *tree, int whichSeq, double *vec, int aSze);
extern void CS_CSCmp(int aSze, int **rfcommut, int **commut, int **rscommut);
 
extern void CS_ClustersRndDefine(FILE *f, DtCSRec *CS, 
				 DtCSClsDef *parms);

extern void CS_initLaws(DtCSRec *pCs);
extern void CS_initThresholds(DtCSRec *pCs);
extern void CS_lawsBuild(DtCSRec *pCs, int **obscs);
extern void CS_OutputLaws(char *fname, DtCSRec *pCs);
extern void CS_InputLaws(char *fname, DtCSRec *pCs);
#endif





