/*
 * PSeq-Gen
 * (c) 1997 N Grassly and A Rambaut
 *	Department of Zoology
 *	Oxford University
 *	pseq-gen.c
 *
 * CMPSeq-Gen addons by
 * P. Tuffery (1997-2000) 
 * INSERM U436, Paris, France
 *
 */

#ifndef __Rates_h__
#define __Rates_h__

#include "CSFuncs.h"
#include "RatesTypes.h"

extern double gammaShape;
extern double gDeltaRate;

extern int numCats;
extern int rateHetero;

extern double gMinRate;
extern double gMaxRate;

extern double *rates;
extern double *refrates;
extern double *obsrates;
extern double *chi2eff;
extern double *currates;
extern double *dmyrates;

extern DtRatesRec  *pR;

extern void argstrRatesPrmtrsUsage();
extern void parseArgstrRatesPrmtrs(int argc,char *argv[]);
extern DtRatesRec *InitRates(int aSze);


extern int checkRates(TTree *tree, int which, double *refrates, double dR);
extern void InputRates(char *fname);
extern void OutputRates(FILE *fp);
extern void SetRates(int aSze, double gammaShape);
extern void SetRatesFromRefSeqs(TTree *tree);
extern void ratesEquilibration(TTree *tree, char *iRootFileName, 
			       int nCycle, int nIter, 
			       double gDeltaRate, double scaling,
			       double refTLen, double deltaTLen);
extern void SetupNoGapMask(TTree *tree, FILE *fp,int **mask);
extern void SetupRateMask(TTree *tree, FILE *fp,int **mask, 
			  double minRate, double maxRate);
extern void SetupMutablepMask(TTree *tree, FILE *fp,int **mask);
extern void initMask(int **mask);
extern void dupMask(int **mask, int *ori);
extern void ReadMask(char *fname, int **mask);
extern void SetupChargeMask(TTree *tree, int **mask, int verbose);
extern int countTrueSites(TTree *tree);

#endif
