/*  Header file for evolve.c                           */

/*  (c) Copyright 1996, Andrew Rambaut & Nick Grassly  */
/*  Department of Zoology, University of Oxford        */

#ifndef _EVOLVE_H_
#define _EVOLVE_H_

#include "tree.h"

extern int numTaxa, numBases;

extern char *aminoAcids;

enum {
	NoRates,
	CodonRates,
	GammaRates,
	UserRates
};

/* prototypes */

extern void SetModel(int model);
extern void CreateSequences(TTree *tree, int aSze);
extern int WhichAminoAcid(char c);
extern void EvolveSequences(TTree *tree, char *fname, DtSiteCSRec *prf, 
			    double scale, double bEpsi, int maxTries);

extern void doEvolveSequences(TTree       *tree, 
			      char        *iRootFileName,
			      DtSiteCSRec *prf,
			      double       scaling, 
			      double       bEpsi, 
			      int          bMaxTries,
			      double      *curTLen, 
			      double       deltaTLen,
			      double       deltaRate, 
			      int          maxTries);
#endif /* _EVOLVE_H_ */
